package console;

import model.*;
import javafx.application.Application;
import javafx.collections.ObservableList;
import javafx.scene.Scene;
import javafx.scene.control.ListCell;
import javafx.scene.control.ListView;
import javafx.stage.Stage;
import javafx.util.Callback;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.collections.ListChangeListener;
import javafx.scene.layout.StackPane;

public class LView extends Application {

    @Override
    public void start(Stage primaryStage) {
        CapteurVirtuel cV1 = new CapteurVirtuel("CaVirt1");
        CapteurVirtuel cV2 = new CapteurVirtuel("CaVirt2");

        Captor c1 = new Captor("c1");
        Captor c2 = new Captor("c2");
        Captor c3 = new Captor("c3");
        Captor c4 = new Captor("c4");
        Captor c5 = new Captor("c5");
        Captor c6 = new Captor("c6");


        ListView<CapteurVirtuel> listview = new ListView<>();


        ObservableList<CapteurVirtuel> captors = FXCollections.observableArrayList(
                captor->new ObservableValue[]{
                        captor.getTempMoyenneProperty()
                }
        );

        captors.addListener((ListChangeListener.Change<? extends CapteurVirtuel> c) ->{
            while (c.next()){
                if (c.wasUpdated()){
                    listview.refresh();
                }
            }
        });

        c1.startThread();
        c2.startThread();
        c3.startThread();
        c4.startThread();
        c5.startThread();
        c6.startThread();

        cV1.addToLesCapteurs(c1);
        cV1.addToLesCapteurs(c2);
        cV1.addToLesCapteurs(c3);
        cV2.addToLesCapteurs(c4);
        cV2.addToLesCapteurs(c5);
        cV2.addToLesCapteurs(c6);

        captors.add(cV1);
        captors.add(cV2);

        listview.setCellFactory(new Callback<>() {

            @Override
            public ListCell<CapteurVirtuel> call(ListView<CapteurVirtuel> captorListView) {
                return new ListCell<>() {
                    @Override
                    protected void updateItem(CapteurVirtuel value, boolean empty) {
                        String text = "";
                        super.updateItem(value, empty);
                        if (value != null) {
                            text = value.getTempMoyenne().toString();
                        }
                        setText(text);
                        String style = null;
                        if (!empty) {
                            assert value != null;
                            if (value.isNegative()) {
                                style = "-fx-text-fill : blue";
                            }
                        }
                        if (!empty && value.isHot()) {
                            style = "-fx-text-fill : red";
                        }
                        setStyle(style);
                    }
                };
            }
        });

        listview.setItems(captors);

        final StackPane root = new StackPane();
        root.getChildren().add(listview);
        final Scene scene = new Scene(root);
        primaryStage.setTitle("ListView");
        primaryStage.setWidth(300);
        primaryStage.setHeight(350);
        primaryStage.setScene(scene);
        primaryStage.show();


    }

}